import 'dart:convert';
import 'dart:typed_data';

import 'package:pointycastle/api.dart';
import 'package:pointycastle/asymmetric/api.dart';


decryptByPublicKey(String data, PublicKey publicKey) {
  try {
//      var keyParameter = () => PrivateKeyParameter<RSAPrivateKey>(privateKey);
    var keyParameter = () => PublicKeyParameter<RSAPublicKey>(publicKey);
    AsymmetricBlockCipher cipher = AsymmetricBlockCipher("RSA/PKCS1");
    cipher.reset();
    cipher.init(false, keyParameter());
    Uint8List bconv = Base64Decoder().convert(data);
    final decrypted = cipher.process(bconv);
    String res = String.fromCharCodes(decrypted);
    return res;
  } catch (e) {
    print(e.toString());
  }
}

encryptByPrivateKey(String data, PrivateKey privateKey) {
  try {
//      var keyParameter = () => PublicKeyParameter<RSAPublicKey>(publicKey);
    var keyParameter = () => PrivateKeyParameter<RSAPrivateKey>(privateKey);
    AsymmetricBlockCipher cipher = AsymmetricBlockCipher("RSA/PKCS1");
    cipher.reset();
    cipher.init(true, keyParameter());
    Uint8List encryptResult = cipher.process(utf8.encode(data) as Uint8List);
    String encrypted = Base64Encoder().convert(encryptResult);
    return encrypted;
  } catch (e) {
    print(e.toString());
  }
}
decryptByPrivateKey(String data,RSAPrivateKey privateKey) {
  try {
    var keyParameter = () => PrivateKeyParameter<RSAPrivateKey>(privateKey);
//      var keyParameter = () => PublicKeyParameter<RSAPublicKey>(publicKey);
    AsymmetricBlockCipher cipher = AsymmetricBlockCipher("RSA/PKCS1");
    cipher.reset();
    cipher.init(false, keyParameter());
    Uint8List bconv = Base64Decoder().convert(data);
    final decrypted = cipher.process(bconv);
    String res = String.fromCharCodes(decrypted);
    return res;
  } catch (e) {
    print(e.toString());
  }
}